package com.github.dockerjava.core.command;

import static com.github.dockerjava.utils.TestUtils.isSwarm;
import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.equalTo;

import java.lang.reflect.Method;
import java.util.List;

import org.testng.ITestResult;
import org.testng.SkipException;
import org.testng.annotations.AfterMethod;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Test;

import com.github.dockerjava.api.exception.DockerException;
import com.github.dockerjava.api.model.Network;
import com.github.dockerjava.client.AbstractDockerClientTest;

@Test(groups = "integration")
public class ListNetworksCmdImplTest extends AbstractDockerClientTest {

    @BeforeTest
    public void beforeTest() throws Exception {
        super.beforeTest();
    }

    @AfterTest
    public void afterTest() {
        super.afterTest();
    }

    @BeforeMethod
    public void beforeMethod(Method method) {
        super.beforeMethod(method);
    }

    @AfterMethod
    public void afterMethod(ITestResult result) {
        super.afterMethod(result);
    }

    @Test
    public void listNetworks() throws DockerException {
        if (isSwarm(dockerClient)) throw new SkipException("Swarm has no network");

        List<Network> networks = dockerClient.listNetworksCmd().exec();

        Network network = findNetwork(networks, "bridge");

        assertThat(network.getName(), equalTo("bridge"));
        assertThat(network.getScope(), equalTo("local"));
        assertThat(network.getDriver(), equalTo("bridge"));
        assertThat(network.getIpam().getDriver(), equalTo("default"));
    }
}
